import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Properties;
import javax.swing.JFrame;
import javax.swing.JPanel;

public class ClientStub extends Applet {

	private static final long serialVersionUID = -883509718509655311L;

	public static Properties parameters = new Properties();

	public static ClientStub instance;
	public JFrame frame;
	public JPanel panel = new JPanel();

	public static ArrayList<Integer> packetIds = new ArrayList<Integer>();

	public static final boolean DISABLE_RSA = false;
	public static final boolean USING_RS = false;
	public static final boolean DUMP_CONFIGS = false;
	public static final boolean DUMP_ICOMPONENTSETTINGS = false;
	public static final boolean DUMP_INTERFACES = false;
	public static boolean USING_ISAAC = false;
	public static String IP = "localhost";
	public static int PORT = 5555;
	public static final String SERVER_NAME = "RS3";
	public static final int REVISION = 788;
	public static final int SUB_REVISION = 1;

	static {
		clear();
	}

	public static void handleIncomingPacket(int packetId) {
		for (int packetIdss : packetIds) {
			if (packetIdss == packetId)
				return;
		}
		packetIds.add(packetId);
		//System.out.println("Incoming packet: "+packetId);
	}

	public static void clear() {
		packetIds.clear();
	}

	public static void main(String[] args) throws MalformedURLException, IOException {
		if (USING_RS)
			USING_ISAAC = true;
		instance = new ClientStub();
		instance.doFrame();
	}

	public static void setParams() throws MalformedURLException, IOException {
		if (USING_RS) {
			for (String line : fetchPageDetails()) {
				if (line.contains("<param name=")) {
					String key = line.split("<param name=\"")[1].split("\" ")[0];
					String value = line.split("value=\"")[1].split("\">'")[0];
					if (value.isEmpty())
						value = "";
					parameters.put(key, value);
				}
			}
		} else {
			parameters.put("separate_jvm", "true");
			parameters.put("image", "http://www.runescape.com/img/game/splash5.gif");
			parameters.put("centerimage", "true");
			parameters.put("java_arguments", "-Xmx384m -Xss2m -Dsun.java2d.noddraw=true -XX:CompileThreshold=1500 -Xincgc -XX:+UseConcMarkSweepGC -XX:+UseParNewGC");
			parameters.put("boxbgcolor", "black");
			parameters.put("boxborder", "false");
			parameters.put("31", "http://world1.runescape.com/html5/client");
			parameters.put("33", "false");
			parameters.put("17", "225");
			parameters.put("8", "0");
			parameters.put("10", "wwGlrZHF5gKN6D3mDdihco3oPeYN2KFybL9hUUFqOvk");
			parameters.put("15", "0");
			parameters.put("21", "0");
			parameters.put("6", "");
			parameters.put("41", "EPirnk20/8OXMF8nZrtMKS2fxFG344Wo");
			parameters.put("18", "true");
			parameters.put("-1", "uuOdHmOt1hfNnlVXF**UqA");
			parameters.put("13", "1120");
			parameters.put("30", "false");
			parameters.put("34", "10284");
			parameters.put("12", "0");
			parameters.put("0", "n4IU5VRG2-gnYlqjUIQBgQ");
			parameters.put("40", "lobby22.runescape.com");
			parameters.put("39", "false");
			parameters.put("16", "1");
			parameters.put("37", "halign=true|valign=true|image=rs3_logo.gif,0,-43|rotatingimage=rs3_loading_spinner.gif,0,47,9.6|progress=true,Verdana,13,0xFFFFFF,0,51");
			parameters.put("9", "http://services.runescape.com/m=gamelogspecs/clientstats?data=");
			parameters.put("4", "false");
			parameters.put("25", "false");
			parameters.put("36", "");
			parameters.put("20", "lobby21.runescape.com");
			parameters.put("1", ".runescape.com");
			parameters.put("11", "");
			parameters.put("22", "false");
			parameters.put("3", "0");
			parameters.put("14", "0");
			parameters.put("24", "");
			parameters.put("35", "");
			parameters.put("28", "false");
			parameters.put("7", "1121");
			parameters.put("27", "841935809");
			parameters.put("26", "false");
			parameters.put("32", "0");
			parameters.put("38", "");
			parameters.put("29", "0");
		}
	}

	public void init() {
		instance = this;
		try {
			doApplet();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	void openFrame() {
		frame = new JFrame(SERVER_NAME + " " + REVISION);
		frame.setLayout(new BorderLayout());
		panel.setLayout(new BorderLayout());
		panel.add(this);
		panel.setPreferredSize(new Dimension(765, 553));
		frame.getContentPane().add(panel, "Center");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		frame.pack();
		frame.setVisible(true);
	}

	void doApplet() throws MalformedURLException, IOException {
		setParams();
		startClient();
	}

	public void doFrame() throws MalformedURLException, IOException {
		setParams();
		openFrame();
		startClient();
	}

	void startClient() {
		try {
			client clnt = new client();
			clnt.supplyApplet(this);
			clnt.init();
			clnt.start();
		} catch (Exception exception) {
			exception.printStackTrace();
		}
	}

	public String getParameter(String string) {
		return (String) parameters.get(string);
	}

	public URL getDocumentBase() {
		return getCodeBase();
	}

	public URL getCodeBase() {
		try {
			if (!USING_RS)
				return new URL("http://" + IP);
			else
				return new URL("http://world1.runescape.com/");
		} catch (Exception exception) {
			exception.printStackTrace();
			return null;
		}
	}

	public static ArrayList<String> fetchPageDetails() throws MalformedURLException, IOException {
		ArrayList<String> pageSource = new ArrayList<String>();
		BufferedReader reader = new BufferedReader(new InputStreamReader(new URL("http://world1.runescape.com").openStream()));
		String line;
		while ((line = reader.readLine()) != null)
			pageSource.add(line);
		reader.close();
		return pageSource;
	}
}